SystemOrganization addCategory: #'Magritte-Seaside-Components'!
SystemOrganization addCategory: #'Magritte-Seaside-Core'!
SystemOrganization addCategory: #'Magritte-Seaside-Decorations'!
SystemOrganization addCategory: #'Magritte-Seaside-Examples'!
SystemOrganization addCategory: #'Magritte-Seaside-Renderer'!
SystemOrganization addCategory: #'Magritte-Seaside-Report'!

!MAFileUploadComponent methodsFor: 'rendering' stamp: 'lr 3/26/2009 21:43'!
renderRemoveOn: html
	html render: self value.
	html text: ' ('; render: self value filesize asFileSize; text: ') '.
	html submitButton on: #remove of: self! !

!MADescribedColumn methodsFor: 'accessing-defaults' stamp: 'lr 4/13/2009 15:33'!
defaultComment
	^ self description comment! !

!MADescribedColumn methodsFor: 'accessing-defaults' stamp: 'lr 4/13/2009 13:21'!
defaultLabel
	^ self description label! !

!MADescribedColumn methodsFor: 'accessing-defaults' stamp: 'lr 4/23/2009 22:48'!
defaultSorter
	^ (self description isSortable and: [ self description isRequired ])
		ifTrue: [ super defaultSorter ]! !

!MADescribedColumn methodsFor: 'accessing' stamp: 'lr 4/13/2009 15:34'!
description: aDescription
	description := aDescription.
	accessor := aDescription accessor! !

!MADescribedColumn methodsFor: 'actions' stamp: 'lr 4/13/2009 13:23'!
stringFor: anObject
	^ self description toString: anObject! !

!MADescribedColumn methodsFor: 'actions' stamp: 'lr 4/13/2009 14:21'!
valueFor: aRow
	^ (super valueFor: aRow) ifNil: [ self description default ]! !

!MAActionColumn methodsFor: 'accessing-defaults' stamp: 'lr 4/13/2009 13:21'!
defaultLabel
	^ String new! !

WARequestHandler subclass: #MAFileModelHandler
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Core'!

!MAFileModelHandler class methodsFor: 'instance creation' stamp: 'lr 4/19/2009 22:46'!
on: aFileModel
	^ self new initializeOn: aFileModel! !

!MAFileModelHandler methodsFor: 'comparing' stamp: 'lr 4/19/2009 22:47'!
= aHandler
	^ self species = aHandler species and: [ self model = aHandler model ]! !

!MAFileModelHandler methodsFor: 'processing' stamp: 'lr 4/19/2009 23:17'!
handleRequest: aRequest
	| response |
	response := WAResponse new.
	response
		cacheForever;
		contentType: self model mimetype;
		headerAt: 'Content-Disposition' put: 'inline; filename="' , self model filename , '"';
		contents: self model contents readStream.
	^ response! !

!MAFileModelHandler methodsFor: 'comparing' stamp: 'lr 4/19/2009 22:47'!
hash
	^ self model hash! !

!MAFileModelHandler methodsFor: 'initialization' stamp: 'lr 4/19/2009 22:46'!
initializeOn: aFileModel
	model := aFileModel! !

!MAFileModelHandler methodsFor: 'accessing' stamp: 'lr 4/19/2009 22:48'!
model
	^ model! !

!MASelectListComponent methodsFor: 'rendering-grouped' stamp: 'lr 7/10/2009 16:00'!
renderGroupsOn: html
	^ self groups do: [ :association |
		html optionGroup
			label: association key;
			with: [ 
				association value
					do: [ :option | self renderOption: option on: html ] ] ]! !

!MASelectListComponent methodsFor: 'rendering-grouped' stamp: 'lr 7/10/2009 16:01'!
renderOption: option on: html
	^ html option
		selected: self value = option;
		callback: [ self value: option ];
		with: (self labelForOption: option)! !

!MARelationComponent methodsFor: 'private' stamp: 'lr 4/1/2009 21:02'!
editorFor: anObject
	^ (self description reference asComponentOn: anObject)
		addValidatedForm;
		yourself! !

!MAFileModel methodsFor: '*magritte-seaside-rendering' stamp: 'lr 3/26/2009 21:39'!
renderOn: html
	"Renders a download link of the receiver."

	html anchor
		title: (String streamContents: [ :stream |
			stream nextPutAll: self filename; nextPutAll: ' ('.
			stream nextPutAll: self filesize asFileSize; nextPutAll: ', '.
			stream nextPutAll: self mimetype; nextPut: $) ]);
		url: (self urlFor: html context);
		with: self filename! !

!MAFileModel methodsFor: '*magritte-seaside-accessing' stamp: 'lr 4/19/2009 23:05'!
urlFor: aRenderContext
	"Answer a link to a request handler for the given file."
	
	^ (aRenderContext registry 
		urlForRequestHandler: (MAFileModelHandler on: self))
			displayString! !

!MAFileModel methodsFor: '*magritte-seaside-accessing' stamp: 'lr 3/26/2009 22:10'!
urlOn: html
	self deprecatedApi: 'Use #urlFor: with the rendering context instead.'.
	^ self urlFor: html context! !

MAObject subclass: #MAColumn
	instanceVariableNames: 'report accessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

!MAColumn class methodsFor: 'testing' stamp: 'lr 4/6/2009 13:20'!
isAbstract
	^ false! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 4/6/2009 13:13'!
accessor
	^ accessor! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 4/13/2009 15:39'!
accessor: anAccessor
	"Set the accessor used to get the column value for a given row object."

	accessor := anAccessor asAccessor! !

!MAColumn methodsFor: 'deprecated' stamp: 'lr 4/13/2009 12:59'!
cascade: anArray
	self deprecatedApi: 'Use MAColumn>>#accessor: instead.'.
	self accessor: anArray! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 4/13/2009 12:53'!
comment
	^ self propertyAt: #comment ifAbsent: [ self defaultComment ]! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 4/13/2009 14:00'!
comment: aString
	"A descriptive comment of this column."

	self propertyAt: #comment put: aString! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 4/6/2009 20:25'!
defaultFilter
	^ false! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 4/13/2009 15:57'!
defaultFormatter
	^ MessageSend receiver: self selector: #stringFor:! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 4/13/2009 13:21'!
defaultLabel
	^ self accessor selector asCapitalizedPhrase! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 4/13/2009 12:58'!
defaultRenderer
	^ MessageSend receiver: self selector: #renderCellContent:on:! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 4/13/2009 15:43'!
defaultSorter
	^ [ :a :b | self sort: a and: b ]! !

!MAColumn methodsFor: 'exporting' stamp: 'lr 4/13/2009 16:00'!
exportContent: anObject index: aNumber on: aStream
	| string |
	string := (self formatter value: anObject) collect: [ :char | 
		char isSeparator
			ifTrue: [ Character space ]
			ifFalse: [ char ] ].
	aStream nextPutAll: string! !

!MAColumn methodsFor: 'exporting' stamp: 'lr 4/13/2009 13:01'!
exportHeadOn: aStream
	self label isNil
		ifFalse: [ aStream nextPutAll: self label ]! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 4/6/2009 19:58'!
filter
	^ self propertyAt: #filter ifAbsent: [ self defaultFilter ]! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 4/13/2009 12:53'!
filter: aBoolean
	"Enable or disable filtering of this column."

	self propertyAt: #filter put: aBoolean! !

!MAColumn methodsFor: 'private' stamp: 'lr 4/6/2009 20:29'!
filterBlock
	^ self 
		propertyAt: #filterValue
		ifPresent: [ :value | [ :row | (self valueFor: row) = value ] ]! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 4/13/2009 14:00'!
footer: aBlock
	"A block that renders the footer of this column."
	
	self propertyAt: #footer put: aBlock! !

!MAColumn methodsFor: 'deprecated' stamp: 'lr 4/13/2009 14:22'!
format
	self deprecatedApi: 'Use MAColumn>>#renderer instead.'.
	^ self renderer! !

!MAColumn methodsFor: 'deprecated' stamp: 'lr 4/13/2009 14:22'!
format: aBlock
	self deprecatedApi: 'Use MAColumn>>#renderer: instead.'.
	self renderer: aBlock! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 4/13/2009 15:57'!
formatter
	^ self propertyAt: #formatter ifAbsent: [ self defaultFormatter ]! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 4/13/2009 15:57'!
formatter: aBlock
	"A block that converts the row value to a string."
	
	self propertyAt: #formatter put: aBlock! !

!MAColumn methodsFor: 'initialization' stamp: 'lr 4/6/2009 13:14'!
initialize
	super initialize.
	self accessor: #yourself! !

!MAColumn methodsFor: 'testing' stamp: 'lr 4/6/2009 20:24'!
isFiltered
	^ self filter! !

!MAColumn methodsFor: 'testing' stamp: 'lr 4/6/2009 20:24'!
isSortable
	^ self report sortEnabled and: [ self sorter notNil ]! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 4/13/2009 12:55'!
label
	^ self propertyAt: #label ifAbsent: [ self defaultLabel ]! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 4/13/2009 14:00'!
label: aString
	"The label of this column, also used to toggle the sort order of this column."
	
	self propertyAt: #label put: aString! !

!MAColumn methodsFor: 'actions' stamp: 'lr 4/6/2009 20:14'!
refresh
	self properties removeKey: #uniqueValues ifAbsent: [ ]! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 4/13/2009 15:36'!
renderCell: anObject index: anInteger on: html
	html tableData: [ self renderer valueWithEnoughArguments: (Array with: anObject with: html with: anInteger) ]! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 4/13/2009 15:57'!
renderCellContent: anObject on: html
	html render: (self formatter value: (self valueFor: anObject))! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 4/6/2009 20:50'!
renderFilterCellOn: html
	html tableHeading: [ self renderFilterContentOn: html ]! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 4/13/2009 15:57'!
renderFilterContentOn: html
	self isFiltered 
		ifFalse: [ ^ self ].
	html form style: 'margin: 0; border: 0; padding: 0;'; with: [
		html select
			beOptional;
			beSubmitOnChange;
			optionalLabel: '(all)';
			labels: self formatter;
			list: self uniqueValues;
			selected: (self propertyAt: #filterValue ifAbsent: [ nil ]);
			callback: [ :value |
				value isNil
					ifTrue: [ self properties removeKey: #filterValue ifAbsent: [ ] ]
					ifFalse: [ self propertyAt: #filterValue put: value ].
				self report refresh ] ]! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 4/13/2009 15:49'!
renderFootContentOn: html
	html render: self footer! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 4/13/2009 15:49'!
renderHeadCellOn: html
	html tableHeading
		title: self comment;
		class: self sorterStyle;
		with: [
			self isSortable
				ifFalse: [ self renderHeadContentOn: html ]
				ifTrue: [
					html anchor
						callback: [ self report sort: self ];
						with: [ self renderHeadContentOn: html ] ] ]! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 4/13/2009 13:01'!
renderHeadContentOn: html
	html render: self label! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 4/13/2009 13:59'!
renderer
	^ self propertyAt: #renderer ifAbsent: [ self defaultRenderer ]! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 4/13/2009 13:59'!
renderer: aBlock
	"A block that renders the row value to HTML."

	self propertyAt: #renderer put: aBlock! !

!MAColumn methodsFor: 'deprecated' stamp: 'lr 4/13/2009 12:59'!
selector: aSymbol
	self deprecatedApi: 'Use MAColumn>>#accessor: instead.'.
	self accessor: aSymbol! !

!MAColumn methodsFor: 'private' stamp: 'lr 4/13/2009 16:04'!
sort: aFirstObject and: aSecondObject
	| one two |
	one := self valueFor: aFirstObject.
	two := self valueFor: aSecondObject.
	(one respondsTo: #<=) ifFalse: [
		one := self formatter value: one.
		two := self formatter value: two ].
	^ one <= two! !

!MAColumn methodsFor: 'private' stamp: 'nl 7/6/2006 08:43'!
sortRows: aCollection
	| result |
	result := SortedCollection new: aCollection size.
	result
		sortBlock: self sorter;
		addAll: aCollection.
	^ self isReversed
		ifFalse: [ result ]
		ifTrue: [ result reversed ]! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 4/13/2009 12:54'!
sorter: aBlock
	"A sort block for this column."

	self propertyAt: #sorter put: aBlock! !

!MAColumn methodsFor: 'private' stamp: 'lr 4/13/2009 14:06'!
stringFor: anObject
	"Answer a string representation of the row value."
	
	^ anObject displayString! !

!MAColumn methodsFor: 'deprecated' stamp: 'lr 4/13/2009 12:59'!
title
	self deprecatedApi: 'Use MAColumn>>#label instead.'.
	^ self label! !

!MAColumn methodsFor: 'deprecated' stamp: 'lr 4/13/2009 13:00'!
title: aString
	self deprecatedApi: 'Use MAColumn>>#label: instead.'.
	self label: aString! !

!MAColumn methodsFor: 'private' stamp: 'lr 4/13/2009 16:29'!
uniqueValues
	"Answer the unique rows with the unique values, used for filtering."

	^ self propertyAt: #uniqueValues ifAbsentPut: [
		| uniqueValues |
		uniqueValues := Dictionary new.
		self report rows
			do: [ :row | uniqueValues at: (self valueFor: row) put: row ].
		uniqueValues := uniqueValues values asArray.
		self sorter isNil
			ifFalse: [ uniqueValues sort: self sorter ].
		uniqueValues
			collect: [ :row | self valueFor: row ] ]! !

!MAColumn methodsFor: 'actions' stamp: 'lr 4/13/2009 14:23'!
valueFor: aRow
	"Answer the column value for aRow."

	^ accessor read: aRow! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 4/13/2009 12:55'!
visible: aBoolean
	"Make this column visible or invisible."
	
	self propertyAt: #visible put: aBoolean! !

!MAExternalFileModel methodsFor: '*magritte-seaside-accessing' stamp: 'lr 3/26/2009 21:37'!
urlFor: aRenderingContext
	^ self baseUrl isNil
		ifTrue: [ super urlFor: aRenderingContext ]
		ifFalse: [ self baseUrl , '/' , (self location reduce: [ :a :b | a , '/' , b ]) , '/' , self filename ]! !

!MAInternalEditorComponent methodsFor: 'private' stamp: 'lr 5/17/2009 22:58'!
buildComponent
	^ self value isNil ifFalse: [ 
		(self description reference asComponentOn: self value)
			setParent: self;
			yourself ]! !

!MAReport methodsFor: 'columns' stamp: 'lr 4/13/2009 15:35'!
addColumnDescription: aDescription
	^ self addColumn: (aDescription reportColumnClass new
		description: aDescription;
		yourself)! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 4/6/2009 20:04'!
defaultShowFilter
	^ false! !

!MAReport methodsFor: 'exporting' stamp: 'lr 6/15/2009 20:07'!
exportBodyOn: aStream
	self cache keysAndValuesDo: [ :index :row |
		self visibleColumns
			do: [ :column |
				column
					exportContent: (column valueFor: row)
					index: index on: aStream ]
			separatedBy: [ aStream tab ].
		aStream nextPut: Character cr ]! !

!MAReport methodsFor: 'exporting' stamp: 'lr 6/15/2009 20:07'!
exportHeaderOn: aStream
	self visibleColumns
		do: [ :each | each exportHeadOn: aStream ]
		separatedBy: [ aStream tab ].
	aStream nextPut: Character cr! !

!MAReport methodsFor: 'private' stamp: 'lr 4/6/2009 20:41'!
filterRows: aCollection
	| filters filter |
	filters := OrderedCollection new.
	self hasRowFilter
		ifTrue: [ filters add: self rowFilter ].
	self columns do: [ :each |
		each isFiltered ifTrue: [
			filter := each filterBlock.
			filter isNil
				ifFalse: [ filters add: filter ] ] ].
	^ filters isEmpty
		ifTrue: [ aCollection ]
		ifFalse: [ aCollection select: [ :row | filters allSatisfy: [ :block | block value: row ] ] ]! !

!MAReport methodsFor: 'rendering-table' stamp: 'lr 4/6/2009 20:30'!
renderTableFilterOn: html
	html tableRow: [
		self visibleColumns do: [ :each |
			each renderFilterCellOn: html ] ]! !

!MAReport methodsFor: 'rendering' stamp: 'lr 4/6/2009 20:03'!
renderTableOn: html
	self showCaption
		ifTrue: [ self renderTableCaptionOn: html ].
	self showSummary
		ifTrue: [ self renderTableSummaryOn: html ].
	html tableHead: [
		self showHeader
			ifTrue: [ self renderTableHeadOn: html ].
		self showFilter
			ifTrue: [ self renderTableFilterOn: html ] ].

	((self showBatch
		and: [ self hasMoreThanOnePage ])
		or: [ self showFooter ]) ifTrue: [
			"we must not produce an empty tfoot element, this is not valid xhtml"
			html tableFoot: [
				self showFooter
					ifTrue: [ self renderTableFootOn: html ].
				self showBatch
					ifTrue: [ self renderTableBatchOn: html ] ] ].

	html tableBody: [
		self showBody
			ifTrue: [ self renderTableBodyOn: html ] ]! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/6/2009 20:04'!
showFilter
	^ properties at: #showFilter ifAbsent: [ self defaultShowFilter ]! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 4/6/2009 20:04'!
showFilter: aBoolean
	properties at: #showFilter put: aBoolean! !
