SystemOrganization addCategory: #'Magritte-Seaside-Core'!
SystemOrganization addCategory: #'Magritte-Seaside-Components'!
SystemOrganization addCategory: #'Magritte-Seaside-Decorations'!
SystemOrganization addCategory: #'Magritte-Seaside-Examples'!
SystemOrganization addCategory: #'Magritte-Seaside-Renderer'!
SystemOrganization addCategory: #'Magritte-Seaside-Report'!

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 4/10/2008 14:17'!
description2000
	^ MABooleanDescription new
		accessor: #showHeader;
		label: 'Show Header';
		priority: 2000;
		yourself! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 4/10/2008 14:17'!
description2100
	^ MABooleanDescription new
		accessor: #showBody;
		label: 'Show Body';
		priority: 2100;
		yourself! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 4/10/2008 14:17'!
description2200
	^ MAStringDescription new
		accessor: #tableEmpty;
		label: 'Empty';
		priority: 2200;
		yourself! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 4/10/2008 14:17'!
description2300
	^ MABooleanDescription new
		accessor: #showFooter;
		label: 'Show Footer';
		priority: 2300;
		yourself! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 4/10/2008 14:17'!
description2400
	^ MABooleanDescription new
		accessor: #showCaption;
		label: 'Show Caption';
		priority: 2300;
		yourself! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 4/10/2008 14:17'!
description2500
	^ MAStringDescription new
		accessor: #tableCaption;
		label: 'Caption';
		priority: 2500;
		yourself! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 4/10/2008 14:17'!
description2600
	^ MABooleanDescription new
		accessor: #showSummary;
		label: 'Show Summary';
		priority: 2600;
		yourself! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 4/10/2008 14:17'!
description2700
	^ MAStringDescription new
		accessor: #tableSummary;
		label: 'Summary';
		priority: 2700;
		yourself! !

!MAReport class methodsFor: 'accessing-description-batch' stamp: 'lr 4/10/2008 14:17'!
description4000
	^ MABooleanDescription new
		accessor: #showBatch;
		label: 'Show Batch';
		priority: 4000;
		yourself! !

!MAReport class methodsFor: 'accessing-description-batch' stamp: 'lr 4/10/2008 14:17'!
description4100
	^ MANumberDescription new
		accessor: #batchSize;
		label: 'Size';
		priority: 4100;
		yourself! !

!MAReport class methodsFor: 'accessing-description-batch' stamp: 'lr 4/10/2008 14:17'!
description4200
	^ MABooleanDescription new
		accessor: #showBatchFirstLast;
		label: 'Show First/Last';
		priority: 4200;
		yourself! !

!MAReport class methodsFor: 'accessing-description-batch' stamp: 'lr 4/10/2008 14:17'!
description4300
	^ MABooleanDescription new
		accessor: #showBatchPreviousNext;
		label: 'Show Previous/Next';
		priority: 4300;
		yourself! !

!MAReport class methodsFor: 'accessing-description-batch' stamp: 'lr 4/10/2008 14:17'!
description4400
	^ MABooleanDescription new
		accessor: #showBatchPages;
		label: 'Show Pages';
		priority: 4400;
		yourself! !

!MAReport methodsFor: 'columns' stamp: 'lr 3/9/2006 11:34'!
addColumnDescription: aDescription
	^ self addColumn: (aDescription reportColumnClass new
		setDescription: aDescription;
		yourself)! !

!MAReport methodsFor: 'exporting' stamp: 'lr 9/26/2007 18:47'!
exportBodyOn: aStream
	self cache withIndexDo: [ :row :index |
		self visibleColumns
			do: [ :column |
				column
					exportContent: (column valueFor: row)
					index: index on: aStream ]
			separatedBy: [ aStream tab ].
		aStream cr ]! !

!MAReport methodsFor: 'exporting' stamp: 'lr 9/26/2007 18:48'!
exportHeaderOn: aStream
	self visibleColumns
		do: [ :each | each exportHeadOn: aStream ]
		separatedBy: [ aStream tab ].
	aStream cr! !

!MAReport methodsFor: 'private' stamp: 'lr 3/9/2006 11:33'!
filterRows: aCollection
	^ self hasRowFilter
		ifFalse: [ aCollection ]
		ifTrue: [ aCollection select: self rowFilter ]! !

!MAReport methodsFor: 'rendering' stamp: 'lr 2/12/2007 19:06'!
renderTableOn: html
	self showCaption
		ifTrue: [ self renderTableCaptionOn: html ].
	self showSummary
		ifTrue: [ self renderTableSummaryOn: html ].
	html tableHead: [
		self showHeader
			ifTrue: [ self renderTableHeadOn: html ] ].

	((self showBatch
		and: [ self hasMoreThanOnePage ])
		or: [ self showFooter ]) ifTrue: [
			"we must not produce an empty tfoot element, this is not valid xhtml"
			html tableFoot: [
				self showFooter
					ifTrue: [ self renderTableFootOn: html ].
				self showBatch
					ifTrue: [ self renderTableBatchOn: html ] ] ].

	html tableBody: [
		self showBody
			ifTrue: [ self renderTableBodyOn: html ] ]! !

Object subclass: #MAColumn
	instanceVariableNames: 'report properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

!MAColumn class methodsFor: 'instance creation' stamp: 'lr 1/26/2008 09:57'!
new
	^ self basicNew initialize! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/9/2006 11:33'!
cascade
	^ self propertyAt: #cascade ifAbsent: [ self defaultCascade ]! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/9/2006 11:33'!
cascade: anArray
	self propertyAt: #cascade put: anArray! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/9/2006 11:33'!
comment
	^ self propertyAt: #comment ifAbsent: [ self defaultComment ]! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/9/2006 11:33'!
comment: aString
	self propertyAt: #comment put: aString! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultCascade
	^ #( yourself )! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultFormat
	^ MessageSend receiver: self selector: #renderCellContent:on:! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 2/12/2007 19:06'!
defaultSorter
	^[ :a :b |
		| x y |
		(x := self valueFor: a) isNil
			or: [ (y := self valueFor: b) notNil
				and: [ x <= y ] ] ]! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultTitle
	^ self cascade first asCapitalizedPhrase! !

!MAColumn methodsFor: 'exporting' stamp: 'lr 3/9/2006 11:33'!
exportContent: anObject index: aNumber on: aStream
	aStream nextPutAll: (anObject asString collect: [ :each |
		each isSeparator
			ifTrue: [ Character space ]
			ifFalse: [ each ] ])! !

!MAColumn methodsFor: 'exporting' stamp: 'lr 3/9/2006 11:33'!
exportHeadOn: aStream
	self title isNil
		ifFalse: [ aStream nextPutAll: self title ]! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/9/2006 11:33'!
footer: aBlock
	self propertyAt: #footer put: aBlock! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/9/2006 11:33'!
format
	^ self propertyAt: #format ifAbsent: [ self defaultFormat ]! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/9/2006 11:33'!
format: aBlock
	self propertyAt: #format put: aBlock! !

!MAColumn methodsFor: 'initialization' stamp: 'lr 1/26/2008 09:58'!
initialize
	properties := Dictionary new! !

!MAColumn methodsFor: 'testing' stamp: 'lr 3/9/2006 11:33'!
isSortable
	^ self report sortEnabled
		and: [ self sorter notNil ]! !

!MAColumn methodsFor: 'accessing-properties' stamp: 'lr 3/9/2006 11:33'!
properties
	^ properties! !

!MAColumn methodsFor: 'accessing-properties' stamp: 'lr 3/9/2006 11:33'!
propertyAt: aSymbol
	^ self properties at: aSymbol! !

!MAColumn methodsFor: 'accessing-properties' stamp: 'lr 3/9/2006 11:33'!
propertyAt: aSymbol ifAbsent: aBlock
	^ self properties at: aSymbol ifAbsent: aBlock! !

!MAColumn methodsFor: 'accessing-properties' stamp: 'lr 3/9/2006 11:33'!
propertyAt: aSymbol ifAbsentPut: aBlock
	^ self properties at: aSymbol ifAbsentPut: aBlock! !

!MAColumn methodsFor: 'accessing-properties' stamp: 'lr 3/9/2006 11:33'!
propertyAt: aSymbol put: anObject
	^ self properties at: aSymbol put: anObject! !

!MAColumn methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
refresh! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 3/10/2007 09:53'!
renderCell: anObject index: anInteger on: html
	html tableData: [
		self format valueWithArguments: ((Array with: anObject with: html with: anInteger)
			first: self format numArgs) ]! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 3/9/2006 11:33'!
renderCellContent: anObject on: html
	html render: (self valueFor: anObject)! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 3/9/2006 11:33'!
renderFootContentOn: html
	self footer isNil
		ifFalse: [ html render: self footer ]! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 8/14/2008 11:59'!
renderHeadCellOn: html
	html tableHeading
		class: self sorterStyle;
		title: (self comment ifNil: ['']);
		with: [
			self isSortable
				ifFalse: [ self renderHeadContentOn: html ]
				ifTrue: [
					html anchor
						callback: [ self report sort: self ];
						with: [
							self renderHeadContentOn: html ] ] ]! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 3/9/2006 11:33'!
renderHeadContentOn: html
	html render: self title! !

!MAColumn methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
selector: aSymbol
	self cascade: (Array with: aSymbol)! !

!MAColumn methodsFor: 'actions' stamp: 'nl 7/6/2006 08:43'!
sortRows: aCollection
	| result |
	result := SortedCollection new: aCollection size.
	result
		sortBlock: self sorter;
		addAll: aCollection.
	^ self isReversed
		ifFalse: [ result ]
		ifTrue: [ result reversed ]! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/9/2006 11:33'!
sorter: aBlock
	self propertyAt: #sorter put: aBlock! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/9/2006 11:33'!
title
	^ self propertyAt: #title ifAbsent: [ self defaultTitle ]! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/9/2006 11:33'!
title: aString
	self propertyAt: #title put: aString! !

!MAColumn methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
valueFor: aRow
	^ self cascade
		inject: aRow
		into: [ :result :each | result perform: each ]! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/9/2006 11:33'!
visible: aBoolean
	self propertyAt: #visible put: aBoolean! !

!MADescribedColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultCascade
	self shouldNotImplement! !

!MADescribedColumn methodsFor: 'accessing-defaults' stamp: 'lr 8/18/2007 10:49'!
defaultSorter
	^ self description isSortable ifTrue: [ super defaultSorter ]! !

!MADescribedColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultTitle
	^ self description label! !

!MADescribedColumn methodsFor: 'exporting' stamp: 'lr 7/2/2008 09:43'!
exportContent: anObject index: aNumber on: aStream
	super exportContent: (self description toString: anObject) index: aNumber on: aStream! !

!MADescribedColumn methodsFor: 'rendering' stamp: 'lr 3/9/2006 11:33'!
renderCellContent: anObject on: html
	html render: (self description toString: (self valueFor: anObject))! !

!MADescribedColumn methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:33'!
setDescription: aDescription
	description := aDescription! !

!MADescribedColumn methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
valueFor: aRow
	^ (aRow readUsing: self description)
		ifNil: [ self description default ]! !

!MAActionColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultTitle
	^ String new! !

!MASelectListComponent methodsFor: 'rendering-grouped' stamp: 'lr 9/3/2008 11:41'!
renderGroupsOn: html
	^ self groups do: [ :association |
		html optionGroup
			label: association key;
			with: [ 
				association value
					do: [ :option | self renderOption: option on: html ] ] ]! !

!MASelectListComponent methodsFor: 'rendering-grouped' stamp: 'lr 4/29/2008 17:05'!
renderOption: option on: html
	^ html option
		selected: self value = option;
		label: (self labelForOption: option);
		callback: [ self value: option ];
		with: option! !

!MARelationComponent methodsFor: 'private' stamp: 'lr 3/9/2006 11:33'!
editorFor: anObject
	^ anObject asComponent
		addValidatedForm;
		yourself! !

!MAFileModel methodsFor: '*magritte-seaside-rendering-mimetypes' stamp: 'lr 2/8/2009 18:58'!
renderDefaultOn: html
	<mimetype: #isApplication priority: 0>

	html anchor
		url: (self urlOn: html);
		with: self filename! !

!MAFileModel methodsFor: '*magritte-seaside-rendering-mimetypes' stamp: 'lr 2/8/2009 18:54'!
renderImageOn: html
	<mimetype: #isImage priority: 0>

	html image url: (self urlOn: html)! !

!MAFileModel methodsFor: '*magritte-seaside-rendering-mimetypes' stamp: 'lr 2/8/2009 19:10'!
renderMediaOn: html
	<mimetype: #isVideo priority: 0>
	<mimetype: #isAudio priority: 0>

	| url |
	url := self urlOn: html.
	(html tag: 'object') 
		attributeAt: 'data' put: url;
		attributeAt: 'type' put: self mimetype;
		with: [ 
			(html tag: 'param')
				attributeAt: 'name' put: 'src';
				with: url.
			(html tag: 'param')
				attributeAt: 'name' put: 'scale';
				with: 'aspect'.
			(html tag: 'param')
				attributeAt: 'name' put: 'autoplay';
				with: 'false'.
			(html tag: 'embed')
				attributeAt: 'src' put: url;
				attributeAt: 'scale' put: 'aspect';
				attributeAt: 'autoplay' put: 'false';
				attributeAt: 'type' put: self mimetype;
				with: [ self renderDefaultOn: html ] ]! !

!MAFileModel methodsFor: '*magritte-seaside-rendering' stamp: 'lr 2/8/2009 18:57'!
renderOn: html
	| pragmas |
	pragmas := Pragma
		allNamed: #mimetype:priority:
		from: self class to: MAFileModel
		sortedByArgument: 2.
	pragmas do: [ :pragma |
		(self perform: pragma arguments first)
			ifTrue: [ ^ self perform: pragma selector with: html ] ].
	self renderDefaultOn: html! !

!MAFileModel methodsFor: '*magritte-seaside-rendering-mimetypes' stamp: 'lr 2/8/2009 18:55'!
renderTextOn: html
	<mimetype: #isText priority: 0>

	| stream |
	stream := self contents readStream.
	html preformatted: [
		html text: (stream next: 800).
		stream atEnd
			ifFalse: [ html text: '...' ] ]! !

!MAFileModel methodsFor: '*magritte-seaside-rendering' stamp: 'lr 1/26/2007 18:54'!
urlOn: html
	^ html context
		urlForDocument: self contents
		mimeType: self mimetype
		fileName: self filename! !

!MAExternalFileModel methodsFor: '*magritte-seaside-accessing' stamp: 'lr 9/28/2007 07:45'!
urlOn: html
	^ self baseUrl isNil
		ifTrue: [ super urlOn: html ]
		ifFalse: [ self baseUrl , '/' , (self location reduce: [ :a :b | a , '/' , b ]) , '/' , self filename ]! !

!MAInternalEditorComponent methodsFor: 'private' stamp: 'lr 3/9/2006 11:33'!
buildComponent
	^ self value asComponent
		setParent: self;
		yourself! !

!MAFileUploadComponent methodsFor: 'rendering' stamp: 'lr 1/26/2007 18:54'!
renderRemoveOn: html
	html anchor
		url: (self value urlOn: html);
		with: self value filename.
	html text: ' ('; render: self value filesize asFileSize; text: ') '.
	html submitButton on: #remove of: self! !
